<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="员工id" prop="employeeId">
        <el-input v-model="formData.employeeId" placeholder="请输入员工id" />
      </el-form-item>
      <el-form-item label="计划离职日期" prop="planQuitTime">
        <el-date-picker
          v-model="formData.planQuitTime"
          type="date"
          value-format="x"
          placeholder="选择计划离职日期"
        />
      </el-form-item>
      <el-form-item label="申请离职日期" prop="applyQuitTime">
        <el-date-picker
          v-model="formData.applyQuitTime"
          type="date"
          value-format="x"
          placeholder="选择申请离职日期"
        />
      </el-form-item>
      <el-form-item label="薪资结算日期" prop="salarySettlementTime">
        <el-date-picker
          v-model="formData.salarySettlementTime"
          type="date"
          value-format="x"
          placeholder="选择薪资结算日期"
        />
      </el-form-item>
      <el-form-item label="离职类型 1 主动离职 2 被动离职 3 退休" prop="quitType">
        <el-select v-model="formData.quitType" placeholder="请选择离职类型 1 主动离职 2 被动离职 3 退休">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="离职原因 1家庭原因 2身体原因 3薪资原因 4交通不便 5工作压力 6管理问题 7无晋升机会 8职业规划 9合同到期放弃续签 10其他个人原因  11试用期内辞退 12违反公司条例 13组织调整/裁员 14绩效不达标辞退 15合同到期不续签 16 其他原因被动离职" prop="quitReason">
        <el-input v-model="formData.quitReason" placeholder="请输入离职原因 1家庭原因 2身体原因 3薪资原因 4交通不便 5工作压力 6管理问题 7无晋升机会 8职业规划 9合同到期放弃续签 10其他个人原因  11试用期内辞退 12违反公司条例 13组织调整/裁员 14绩效不达标辞退 15合同到期不续签 16 其他原因被动离职" />
      </el-form-item>
      <el-form-item label="备注" prop="remarks">
        <el-input v-model="formData.remarks" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="离职前状态" prop="oldStatus">
        <el-radio-group v-model="formData.oldStatus">
          <el-radio value="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { EmployeeQuitInfoApi, EmployeeQuitInfo } from '@/api/hr/employeequitinfo'

/** 离职信息 表单 */
defineOptions({ name: 'EmployeeQuitInfoForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  quitInfoId: undefined,
  employeeId: undefined,
  planQuitTime: undefined,
  applyQuitTime: undefined,
  salarySettlementTime: undefined,
  quitType: undefined,
  quitReason: undefined,
  remarks: undefined,
  oldStatus: undefined,
})
const formRules = reactive({
  employeeId: [{ required: true, message: '员工id不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await EmployeeQuitInfoApi.getEmployeeQuitInfo(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as EmployeeQuitInfo
    if (formType.value === 'create') {
      await EmployeeQuitInfoApi.createEmployeeQuitInfo(data)
      message.success(t('common.createSuccess'))
    } else {
      await EmployeeQuitInfoApi.updateEmployeeQuitInfo(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    quitInfoId: undefined,
    employeeId: undefined,
    planQuitTime: undefined,
    applyQuitTime: undefined,
    salarySettlementTime: undefined,
    quitType: undefined,
    quitReason: undefined,
    remarks: undefined,
    oldStatus: undefined,
  }
  formRef.value?.resetFields()
}
</script>
